> For the complete documentation index, see [llms.txt](https://developers.cryptopay.me/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developers.cryptopay.me/guides/channels/callbacks.md).

# Channel payment callbacks

{% hint style="danger" %}
Handling callbacks correctly is crucial to ensure your integration’s business logic works as expected. It is highly recommended to validate payment statuses and callbacks before acting on it inside your system.
{% endhint %}

Refer to [this section](/guides/api-basics/callbacks.md) to get more information on what callbacks are and how to validate them before acting on it inside your system.

| Callback event | Description                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       |
| -------------- | ----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| `created`      | A customer has just broadcast their transaction on the network                                                                                                                                                                                                                                                                                                                                                                                                                                                    |
| `completed`    | The transaction has just been confirmed on the network. The channel payment status has been changed to `completed`                                                                                                                                                                                                                                                                                                                                                                                                |
| `on_hold`      | The received cryptocurrency transaction evaluated as High-Risk, therefore the Channel Payment transaction has been put on hold. Our Transaction Monitoring team will review this transaction to make a decision on whether we will be able to process this payment and add the funds to your merchant account balance or we will have to send the funds back to a sender. Refer to the [Risks](/guides/risks.md) section to get more details on what High-Risk transactions are and why we take it very seriously |
| `refunded`     | The funds have been returned back to the sender                                                                                                                                                                                                                                                                                                                                                                                                                                                                   |
| `cancelled`    | The transaction was on the network but hasn't been confirmed within 14 days. The channel payment status has been changed to `cancelled`                                                                                                                                                                                                                                                                                                                                                                           |

{% tabs %}
{% tab title="created" %}

```javascript
{
    "data": {
        "id": "912345fb-6de2-4e50-9fae-b139c3c12345",
        "fee": "0.0",
        "risk": null,
        "txid": "aad38eb9a4b22fefa1234569bb78061120bb4b123458b650606765d1c8412345",
        "status": "pending",
        "address": "TC2Vxwky12345xwGcqPt2xy7jynvF12345",
        "network": "tron",
        "custom_id": "1234567",
        "channel_id": "17b12345-109a-4a27-af93-d955e4112345",
        "created_at": "2025-08-01T11:06:09+00:00",
        "customer_id": null,
        "paid_amount": "229.503834",
        "fee_currency": "TRX",
        "paid_currency": "TRX",
        "refund_address": null,
        "status_context": null,
        "received_amount": "0.0",
        "source_addresses": [
            "TAzsQ9Gx8eq12345beXrbi45CuVPH12345"
        ],
        "received_currency": "TRX",
        "coin_withdrawal_id": null
    },
    "type": "ChannelPayment",
    "event": "created"
}
```

{% endtab %}

{% tab title="completed" %}

```javascript
{
    "data": {
        "id": "912345fb-6de2-4e50-9fae-b139c3c12345",
        "fee": "1.606527",
        "risk": {
            "level": "low",
            "score": 0,
            "resource_name": "Binance.com",
            "resource_category": null
        },
        "txid": "aad38eb9a4b22fefa1234569bb78061120bb4b1234567850606765d1c8412345",
        "status": "completed",
        "address": "TC2Vxwky12345xwGcqPt2xy7jynvF12345",
        "network": "tron",
        "custom_id": "1234567",
        "channel_id": "17b12345-109a-4a27-af93-d955e4112345",
        "created_at": "2025-08-01T11:06:09+00:00",
        "customer_id": null,
        "paid_amount": "229.503834",
        "fee_currency": "TRX",
        "paid_currency": "TRX",
        "refund_address": null,
        "status_context": null,
        "received_amount": "227.897307",
        "source_addresses": [
            "TAzsQ9Gx8eq12345beXrbi45CuVPH12345"
        ],
        "received_currency": "TRX",
        "coin_withdrawal_id": null
    },
    "type": "ChannelPayment",
    "event": "completed"
}
```

{% endtab %}

{% tab title="on\_hold" %}

```javascript
{
    "data": {
        "id": "57212345-1458-4c0e-8ca7-a4418b012345",
        "fee": "0.0",
        "risk": {
            "level": "high",
            "score": 0,
            "resource_name": "Kraken Market",
            "resource_category": null
        },
        "txid": "0b8461234589c7bcc214de12345e9cd9b12345345d83f54eebb347f12345e8b2",
        "status": "on_hold",
        "address": "bc1qg12345j4a449nl2e12345kvzyplwfp7312345n9vpay812345vask12345",
        "network": "bitcoin",
        "custom_id": "1234567",
        "channel_id": "12345fe9-04f4-47d6-9668-12345123455e",
        "created_at": "2025-08-01T07:05:30+00:00",
        "customer_id": null,
        "paid_amount": "0.00382471",
        "fee_currency": "BTC",
        "paid_currency": "BTC",
        "refund_address": null,
        "status_context": "illicit_resource",
        "received_amount": "0.0",
        "source_addresses": [
            "bc1qcax12345s23xpede12345fwdner96qudg12345"
        ],
        "received_currency": "BTC",
        "coin_withdrawal_id": null
    },
    "type": "ChannelPayment",
    "event": "on_hold"
}
```

{% endtab %}

{% tab title="refunded" %}

```javascript
{
    "data": {
        "id": "123454dc-0a4b-4288-9440-2bdf53c12345",
        "fee": "0.0",
        "risk": {
            "level": "low",
            "score": 0,
            "resource_name": null,
            "resource_category": null
        },
        "txid": "1842ED39663952123456C1AA4D123455A592949123457F3B000023CB96112345",
        "status": "refunded",
        "address": "rHZMaubybZzb6fy12345zQw1Ax7R812345?dt=12345",
        "network": "ripple",
        "custom_id": "1234567",
        "channel_id": "2d612345-a4ae-48b2-8a07-569458612345",
        "created_at": "2025-07-30T12:09:30+00:00",
        "customer_id": null,
        "paid_amount": "0.0001",
        "fee_currency": "XRP",
        "paid_currency": "XRP",
        "refund_address": null,
        "status_context": null,
        "received_amount": "0.0001",
        "source_addresses": [
            "rEni1epjkJfVXMmMaDD12345Fe1mY12345"
        ],
        "received_currency": "XRP",
        "coin_withdrawal_id": null
    },
    "type": "ChannelPayment",
    "event": "refunded"
}
```

{% endtab %}

{% tab title="cancelled" %}

```javascript
{
    "data": {
        "id": "0882c257-87de-4322-b4fa-4984ed912345",
        "fee": "0.0",
        "risk": null,
        "txid": "8263fc155dff13d6ddf812345cab04701dc3241e12345e205889a2ebf0412345",
        "status": "cancelled",
        "address": "bc1qft2kryup2nlu5a7rh123453mv8zlwmfgpct9dhagh123456ky6jqj12345",
        "network": "bitcoin",
        "custom_id": "1234567",
        "channel_id": "70512345-2833-4f10-a876-ec39c3b12345",
        "created_at": "2025-06-12T15:52:24+00:00",
        "customer_id": null,
        "paid_amount": "0.00020523",
        "fee_currency": "BTC",
        "paid_currency": "BTC",
        "refund_address": null,
        "status_context": null,
        "received_amount": "0.0",
        "source_addresses": [
            "bc1qmz7ffpz39x5gd3q4d012345vd7hknfn9312345"
        ],
        "received_currency": "BTC",
        "coin_withdrawal_id": null
    },
    "type": "ChannelPayment",
    "event": "cancelled"
}
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developers.cryptopay.me/guides/channels/callbacks.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
